/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

#include "prelude.h"

// tri par tas

void move_down(int a[], int i, int x, int n) {
  while (true) {
    int j = 2 * i + 1;
    if (j >= n) break;
    if (j + 1 < n && a[j] < a[j + 1]) { j++; }
    if (a[j] <= x) break;
    a[i] = a[j];
    i = j;
  }
  a[i] = x;
}

void heapsort_(int a[], int n) {
  for (int k = n / 2 - 1; k >= 0; k--)
    move_down(a, k, a[k], n);
  for (int k = n - 1; k >= 1; k--) {
    int v = a[k];
    a[k] = a[0];
    move_down(a, 0, v, k);
  }
}
